/*
 *
 *  Created on: Mar 1, 2021
 *      Author: astrisw
 */

#ifndef REDISPROVIDER_H_
#define REDISPROVIDER_H_

#include <Base_Provider.h>
#include <unordered_map>
#include <hiredis/hiredis.h>

namespace inaf::oasbo::Providers {

class RedisProvider : public BaseProvider{
protected:
	redisContext *context = nullptr;
	std::string ip;
	int port;
	std::string & key = *(&this->dest);

	void setDest(std::string dest){setKey(dest);}
	std::string getDest(){return getKey();}


public:
	RedisProvider();
	RedisProvider(std::string ip, int port, std::string key);

	void setIp(std::string ip){this->ip=ip;}
	void setPort(int port){this->port=port;}
	void setKey(std::string key){this->key=key;}


	std::string getIp(){return this->ip;}
	int getPort(){return this->port;}
	std::string getKey(){return this->key;}


	int write(PacketLib::BasePacket &);
	int write(PacketLib::BasePacket &, std::string dest);

	int close();
	int open();
	bool isOpen() override;
	~RedisProvider();

};
}
#endif /* REDISPROVIDER_H_ */
